<template>
    <div class="fit" :meta="Computed">
        <Chart ref="chart" class="fit" v-if="graph != null"
               :subtitle="Subtitle"
               :graph="graph.graph" :graph-setting="graph.settings" :title="graph.title"/>
    </div>
</template>

<script lang='ts'>
import {Component, Prop, Vue} from 'vue-property-decorator';
import Chart from "components/Core/Chart.vue";
import {
    FloorChartRetriever,
    FloorChartValueType,
    FloorChartVariableType,
    FloorGraphOption
} from "src/classLibrary/Charting/FloorChart";
import {GraphSetting} from "src/classLibrary/Charting/GraphSetting";
import {format} from "date-fns";
import {Graph, GraphValue} from "src/classLibrary/Charting/DataSet";
import {GraphExportType} from "src/classLibrary/Constants";

@Component({
    components: {Chart}
})
export default class FloorChart extends Vue {
    @Prop() options!: FloorGraphOption;
    @Prop() settings!: GraphSetting;
    @Prop() days!: string[];

    Download(type: GraphExportType) {
        return (this.$refs.chart as any).Download(type);
    }

    get Computed() {
        this.Graph().then(e => {
            this.graph = e
        });

        // Basically a watcher
        return this.options && this.days && this.settings;
    }

    get Subtitle() {
        return this.options.valueType === 'value' ? 'Average number of workers' : 'Total Man Hours';
    }

    GraphTitleAxis(f: FloorChartVariableType) {
        if (f === 'sub') {
            return 'Zones grouped by SubContractor'
        } else {
            return 'SubContractor grouped by Zones'
        }
    }

    GraphTitleValue(f: FloorChartValueType) {
        if (f === 'value') {
            return "Number of worker in each"
        } else {
            return "Man hours for each"
        }
    }

    DependentType(): GraphValue {
        if (this.options.valueType === 'value') {
            return GraphValue.Precision(2);
        } else {
            return GraphValue.Hours();
        }
    }

    ValueType(): GraphValue {
        if (this.options.valueType === 'value') {
            return GraphValue.Precision(2);
        } else {
            return GraphValue.Hours();
        }
    }

    query: FloorChartRetriever = new FloorChartRetriever(this.$auth, this.$analyticsApi);

    graph: { settings: GraphSetting, graph: Graph, title: string } | null = null;


    async Graph(): Promise<{ settings: GraphSetting, graph: Graph, title: string } | null> {
        const d = await this.query.Query(this.options, this.days, this.PersistentStore.StoreValue.projectName);
        if (d.isErr()) {
            console.error("error from query", d.unwrapErr());
            this.$emit('error', d.unwrapErr())
            return null;
        }
        const g = d.unwrap();
        if (g == null) return g;
        const startDate = format(new Date(this.options.startTime), "dd MMM yyyy");
        const endDate = format(new Date(this.options.endTime), "dd MMM yyyy");
        const vType = this.GraphTitleValue(this.options.valueType);
        const axisType = this.GraphTitleAxis(this.options.independent);
        const title = `${startDate} - ${endDate}: ${vType} ${axisType}`;

        const independentType = GraphValue.Original();
        const dependentType = this.DependentType();
        const valueType = this.ValueType();

        const data = g

        const graph = {
            type: this.options.type,
            title,
            dependentType,
            independentType,
            valueType,
            data,
        }
        return {graph, title, settings: this.settings}
    }

}
</script>

<style lang='scss' scoped>

</style>
